--- gcc-4.0.0.orig/libcpp/system.h	12 Jun 2004 05:53:54 -0000	1.3
+++ gcc-4.0.0/libcpp/system.h	24 Apr 2005 22:54:11 -0000	1.3.44.1
@@ -38,6 +38,11 @@
 #define NULL 0
 #endif
 
+/* Use the unlocked open routines from libiberty.  */
+#define fopen(PATH,MODE) fopen_unlocked(PATH,MODE)
+#define fdopen(FILDES,MODE) fdopen_unlocked(FILDES,MODE)
+#define freopen(PATH,MODE,STREAM) freopen_unlocked(PATH,MODE,STREAM)
+
 /* The compiler is not a multi-threaded application and therefore we
    do not have to use the locking functions.  In fact, using the locking
    functions can cause the compiler to be significantly slower under
@@ -57,11 +62,65 @@
 #  undef putc
 #  define putc(C, Stream) putc_unlocked (C, Stream)
 # endif
+# ifdef HAVE_PUTCHAR_UNLOCKED
+#  undef putchar
+#  define putchar(C) putchar_unlocked (C)
+# endif
+# ifdef HAVE_GETC_UNLOCKED
+#  undef getc
+#  define getc(Stream) getc_unlocked (Stream)
+# endif
+# ifdef HAVE_GETCHAR_UNLOCKED
+#  undef getchar
+#  define getchar() getchar_unlocked ()
+# endif
 # ifdef HAVE_FPUTC_UNLOCKED
 #  undef fputc
 #  define fputc(C, Stream) fputc_unlocked (C, Stream)
 # endif
 
+# ifdef HAVE_CLEARERR_UNLOCKED
+#  undef clearerr
+#  define clearerr(Stream) clearerr_unlocked (Stream)
+#  if defined (HAVE_DECL_CLEARERR_UNLOCKED) && !HAVE_DECL_CLEARERR_UNLOCKED
+extern void clearerr_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FEOF_UNLOCKED
+#  undef feof
+#  define feof(Stream) feof_unlocked (Stream)
+#  if defined (HAVE_DECL_FEOF_UNLOCKED) && !HAVE_DECL_FEOF_UNLOCKED
+extern int feof_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FILENO_UNLOCKED
+#  undef fileno
+#  define fileno(Stream) fileno_unlocked (Stream)
+#  if defined (HAVE_DECL_FILENO_UNLOCKED) && !HAVE_DECL_FILENO_UNLOCKED
+extern int fileno_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FFLUSH_UNLOCKED
+#  undef fflush
+#  define fflush(Stream) fflush_unlocked (Stream)
+#  if defined (HAVE_DECL_FFLUSH_UNLOCKED) && !HAVE_DECL_FFLUSH_UNLOCKED
+extern int fflush_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FGETC_UNLOCKED
+#  undef fgetc
+#  define fgetc(Stream) fgetc_unlocked (Stream)
+#  if defined (HAVE_DECL_FGETC_UNLOCKED) && !HAVE_DECL_FGETC_UNLOCKED
+extern int fgetc_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FGETS_UNLOCKED
+#  undef fgets
+#  define fgets(S, n, Stream) fgets_unlocked (S, n, Stream)
+#  if defined (HAVE_DECL_FGETS_UNLOCKED) && !HAVE_DECL_FGETS_UNLOCKED
+extern char *fgets_unlocked (char *, int, FILE *);
+#  endif
+# endif
 # ifdef HAVE_FPUTS_UNLOCKED
 #  undef fputs
 #  define fputs(String, Stream) fputs_unlocked (String, Stream)
@@ -69,11 +128,25 @@
 extern int fputs_unlocked (const char *, FILE *);
 #  endif
 # endif
+# ifdef HAVE_FERROR_UNLOCKED
+#  undef ferror
+#  define ferror(Stream) ferror_unlocked (Stream)
+#  if defined (HAVE_DECL_FERROR_UNLOCKED) && !HAVE_DECL_FERROR_UNLOCKED
+extern int ferror_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FREAD_UNLOCKED
+#  undef fread
+#  define fread(Ptr, Size, N, Stream) fread_unlocked (Ptr, Size, N, Stream)
+#  if defined (HAVE_DECL_FREAD_UNLOCKED) && !HAVE_DECL_FREAD_UNLOCKED
+extern size_t fread_unlocked (void *, size_t, size_t, FILE *);
+#  endif
+# endif
 # ifdef HAVE_FWRITE_UNLOCKED
 #  undef fwrite
 #  define fwrite(Ptr, Size, N, Stream) fwrite_unlocked (Ptr, Size, N, Stream)
 #  if defined (HAVE_DECL_FWRITE_UNLOCKED) && !HAVE_DECL_FWRITE_UNLOCKED
-extern int fwrite_unlocked (const void *, size_t, size_t, FILE *);
+extern size_t fwrite_unlocked (const void *, size_t, size_t, FILE *);
 #  endif
 # endif
 # ifdef HAVE_FPRINTF_UNLOCKED
--- gcc-4.0.0.orig/libcpp/po/ChangeLog	21 Apr 2005 05:19:54 -0000	1.7.12.7
+++ gcc-4.0.0/libcpp/po/ChangeLog	27 Apr 2005 16:02:24 -0000	1.7.12.8
@@ -1,3 +1,8 @@
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* be.po, ca.po, da.po, de.po, el.po, es.po, fr.po, ja.po, nl.po,
+	rw.po, sv.po, tr.po, vi.po: Update.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/libffi/configure.ac	2 Dec 2004 11:04:21 -0000	1.9
+++ gcc-4.0.0/libffi/configure.ac	2 May 2005 04:37:41 -0000
@@ -46,6 +46,7 @@
 i*86-*-beos*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-freebsd* | i*86-*-kfreebsd*-gnu) TARGET=X86; TARGETDIR=x86;;
 i*86-*-netbsdelf* | i*86-*-knetbsd*-gnu) TARGET=X86; TARGETDIR=x86;;
+i*86-*-rtems*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-win32*) TARGET=X86_WIN32; TARGETDIR=x86;;
 i*86-*-cygwin*) TARGET=X86_WIN32; TARGETDIR=x86;;
 i*86-*-mingw*) TARGET=X86_WIN32; TARGETDIR=x86;;
@@ -53,11 +54,13 @@
 sparc-sun-4*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc*-sun-*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc-*-linux* | sparc-*-netbsdelf* | sparc-*-knetbsd*-gnu) TARGET=SPARC; TARGETDIR=sparc;;
+sparc*-*-rtems*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc64-*-linux* | sparc64-*-netbsd* | sparc64-*-knetbsd*-gnu) TARGET=SPARC; TARGETDIR=sparc;;
 alpha*-*-linux* | alpha*-*-osf* | alpha*-*-freebsd* | alpha*-*-kfreebsd*-gnu | alpha*-*-netbsd* | alpha*-*-knetbsd*-gnu) TARGET=ALPHA; TARGETDIR=alpha;;
 ia64*-*-*) TARGET=IA64; TARGETDIR=ia64;;
 m32r*-*-linux* ) TARGET=M32R; TARGETDIR=m32r;;
 m68k-*-linux*) TARGET=M68K; TARGETDIR=m68k;;
+m68k-*-rtems*) TARGET=M68K; TARGETDIR=m68k;;
 mips64*-*);;
 mips-sgi-irix5.* | mips-sgi-irix6.*) TARGET=MIPS_IRIX; TARGETDIR=mips;;
 mips*-*-linux*) TARGET=MIPS_LINUX; TARGETDIR=mips;;
@@ -65,13 +68,16 @@
 powerpc-*-beos*) TARGET=POWERPC; TARGETDIR=powerpc;;
 powerpc-*-darwin*) TARGET=POWERPC_DARWIN; TARGETDIR=powerpc;;
 powerpc-*-aix*) TARGET=POWERPC_AIX; TARGETDIR=powerpc;;
+powerpc*-*-rtems*) TARGET=POWERPC; TARGETDIR=powerpc;;
 rs6000-*-aix*) TARGET=POWERPC_AIX; TARGETDIR=powerpc;;
 arm*-*-linux-*) TARGET=ARM; TARGETDIR=arm;;
 arm*-*-netbsdelf* | arm*-*-knetbsd*-gnu) TARGET=ARM; TARGETDIR=arm;;
+arm*-*-rtems*) TARGET=ARM; TARGETDIR=arm;;
 s390-*-linux-*) TARGET=S390; TARGETDIR=s390;;
 s390x-*-linux-*) TARGET=S390; TARGETDIR=s390;;
 x86_64-*-linux* | x86_64-*-freebsd* | x86_64-*-kfreebsd*-gnu) TARGET=X86_64; TARGETDIR=x86;;
 sh-*-linux* | sh[[34]]*-*-linux*) TARGET=SH; TARGETDIR=sh;;
+sh-*-rtems*) TARGET=SH; TARGETDIR=sh;;
 sh64-*-linux* | sh5*-*-linux*) TARGET=SH64; TARGETDIR=sh64;;
 hppa-*-linux* | parisc-*-linux*) TARGET=PA; TARGETDIR=pa;;
 esac
--- gcc-4.0.0.orig/libgfortran/ChangeLog	21 Apr 2005 05:20:00 -0000	1.163.2.19
+++ gcc-4.0.0/libgfortran/ChangeLog	29 Apr 2005 14:24:46 -0000	1.163.2.22
@@ -1,12 +1,30 @@
+2005-04-29  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+
+	* configure.ac: Check for ftruncate and chsize.
+	* io/unix.c (fd_truncate): Provide chsize as alternative to
+	ftruncate.
+	* config.h.in: Regenerate.
+	* configure: Regenerate.
+
+2004-04-28  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>
+
+	* AUTHORS, COPYING, INSTALL, NEWS, README: Remove.
+
+2005-04-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+
+	PR libfortran/20950
+	* io/inquire.c (inquire_via_unit): Check for the gfc_unit being
+	NULL when setting ioparm.sequential.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
 
 2005-04-13  Thomas Koenig <Thomas.Koenig@online.de>
 
-        PR libfortran/20163
+	PR libfortran/20163
 	* runtime/string.c (compare0): Use fstrlen() to
-        strip trailing blanks from option string.
+	strip trailing blanks from option string.
 
 
 2005-04-08  Eric Botcazou  <ebotcazou@libertysurf.fr>
@@ -30,7 +48,7 @@
 	the scale factor, but it needs to be restored afterwards.
 
 2005-04-03  Dale Ranta  <dir@lanl.gov>
-            Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+	Francois-Xavier Coudert  <coudert@clipper.ens.fr>
 
 	PR libfortran/20068
 	PR libfortran/20125
--- gcc-4.0.0.orig/libgfortran/config.h.in	24 Mar 2005 17:28:03 -0000	1.16.12.1
+++ gcc-4.0.0/libgfortran/config.h.in	29 Apr 2005 14:24:46 -0000	1.16.12.2
@@ -30,6 +30,9 @@
 /* Define to 1 if you have the `chdir' function. */
 #undef HAVE_CHDIR
 
+/* Define to 1 if you have the `chsize' function. */
+#undef HAVE_CHSIZE
+
 /* complex.h exists */
 #undef HAVE_COMPLEX_H
 
@@ -69,6 +72,9 @@
 /* libm includes frexpf */
 #undef HAVE_FREXPF
 
+/* Define to 1 if you have the `ftruncate' function. */
+#undef HAVE_FTRUNCATE
+
 /* libc includes getgid */
 #undef HAVE_GETGID
 
--- gcc-4.0.0.orig/libgfortran/configure.ac	7 Apr 2005 22:40:08 -0000	1.20.12.2
+++ gcc-4.0.0/libgfortran/configure.ac	29 Apr 2005 14:24:48 -0000	1.20.12.3
@@ -168,7 +168,7 @@
 AC_CHECK_LIB([m],[csin],[need_math="no"],[need_math="yes"])
 
 # Check for library functions.
-AC_CHECK_FUNCS(getrusage times mkstemp strtof snprintf)
+AC_CHECK_FUNCS(getrusage times mkstemp strtof snprintf ftruncate chsize)
 AC_CHECK_FUNCS(chdir strerror getlogin gethostname kill link symlink perror)
 AC_CHECK_FUNCS(sleep time)
 
--- gcc-4.0.0.orig/libgfortran/io/inquire.c	31 Mar 2005 15:36:09 -0000	1.9.8.1
+++ gcc-4.0.0/libgfortran/io/inquire.c	27 Apr 2005 18:15:39 -0000	1.9.8.2
@@ -87,13 +87,16 @@
 
   if (ioparm.sequential != NULL)
     {
-      /* disallow an open direct access file to be accessed
-         sequentially */
-      if (u->flags.access==ACCESS_DIRECT)
-        p = "NO";
-      else   
-        p = (u == NULL) ? inquire_sequential (NULL, 0) :
-        inquire_sequential (u->file, u->file_len);
+      if (u == NULL)
+	p = inquire_sequential (NULL, 0);
+      else
+	{
+          /* disallow an open direct access file to be accessed sequentially */
+          if (u->flags.access == ACCESS_DIRECT)
+            p = "NO";
+          else   
+            p = inquire_sequential (u->file, u->file_len);
+	}
 
       cf_strcpy (ioparm.sequential, ioparm.sequential_len, p);
     }
--- gcc-4.0.0.orig/libgfortran/io/unix.c	23 Jan 2005 00:14:31 -0000	1.21
+++ gcc-4.0.0/libgfortran/io/unix.c	29 Apr 2005 14:24:49 -0000	1.21.10.1
@@ -513,8 +513,15 @@
   /* non-seekable files, like terminals and fifo's fail the lseek.
      the fd is a regular file at this point */
 
+#ifdef HAVE_FTRUNCATE
   if (ftruncate (s->fd, s->logical_offset))
     return FAILURE;
+#else
+#ifdef HAVE_CHSIZE
+  if (chsize (s->fd, s->logical_offset))
+    return FAILURE;
+#endif
+#endif
 
   s->physical_offset = s->file_length = s->logical_offset;
 
--- gcc-4.0.0.orig/libiberty/ChangeLog	21 Apr 2005 05:20:04 -0000	1.541.4.1
+++ gcc-4.0.0/libiberty/ChangeLog	26 Apr 2005 00:17:19 -0000	1.541.4.3
@@ -1,3 +1,26 @@
+2005-04-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* fopen_unlocked.c (unlock_std_streams): New.
+	
+	* functions.texi: Regenerate.
+
+2005-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* Makefile.in (CFILES): Add fopen_unlocked.c.
+	(REQUIRED_OFILES): Add ./fopen_unlocked.o.
+	Regenerate dependencies.
+
+	* configure.ac: Check for stdio_ext.h and __fsetlocking.
+
+	* fopen_unlocked.c: New file.
+
+	* functions.texi, configure, config.in: Regenerate.
+
+	* fopen_unlocked.c (unlock_stream): New.
+	Consolidate unlocking code into a helper function.
+
+	* functions.texi: Regenerate.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/libiberty/config.in	10 Dec 2004 21:24:59 -0000	1.36
+++ gcc-4.0.0/libiberty/config.in	24 Apr 2005 22:52:42 -0000	1.36.10.1
@@ -151,6 +151,9 @@
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
+/* Define to 1 if you have the <stdio_ext.h> header file. */
+#undef HAVE_STDIO_EXT_H
+
 /* Define to 1 if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
@@ -313,6 +316,9 @@
 /* Define if you have the _system_configuration variable. */
 #undef HAVE__SYSTEM_CONFIGURATION
 
+/* Define to 1 if you have the `__fsetlocking' function. */
+#undef HAVE___FSETLOCKING
+
 /* Define if the host machine stores words of multi-word integers in
    big-endian order. */
 #undef HOST_WORDS_BIG_ENDIAN
--- gcc-4.0.0.orig/libiberty/configure.ac	27 Dec 2004 21:00:12 -0000	1.11
+++ gcc-4.0.0/libiberty/configure.ac	24 Apr 2005 22:52:41 -0000	1.11.12.1
@@ -159,7 +159,7 @@
 # It's OK to check for header files.  Although the compiler may not be
 # able to link anything, it had better be able to at least compile
 # something.
-AC_CHECK_HEADERS(sys/file.h sys/param.h limits.h stdlib.h malloc.h string.h unistd.h strings.h sys/time.h time.h sys/resource.h sys/stat.h sys/mman.h fcntl.h alloca.h sys/pstat.h sys/sysmp.h sys/sysinfo.h machine/hal_sysinfo.h sys/table.h sys/sysctl.h sys/systemcfg.h stdint.h)
+AC_CHECK_HEADERS(sys/file.h sys/param.h limits.h stdlib.h malloc.h string.h unistd.h strings.h sys/time.h time.h sys/resource.h sys/stat.h sys/mman.h fcntl.h alloca.h sys/pstat.h sys/sysmp.h sys/sysinfo.h machine/hal_sysinfo.h sys/table.h sys/sysctl.h sys/systemcfg.h stdint.h stdio_ext.h)
 AC_HEADER_SYS_WAIT
 AC_HEADER_TIME
 
@@ -266,7 +266,7 @@
 
 checkfuncs="getrusage on_exit psignal strerror strsignal sysconf times sbrk gettimeofday"
 checkfuncs="$checkfuncs realpath canonicalize_file_name pstat_getstatic pstat_getdynamic sysmp"
-checkfuncs="$checkfuncs getsysinfo table sysctl"
+checkfuncs="$checkfuncs getsysinfo table sysctl __fsetlocking"
 
 # These are neither executed nor required, but they help keep
 # autoheader happy without adding a bunch of text to acconfig.h.
@@ -279,7 +279,7 @@
   vsprintf waitpid getrusage on_exit psignal strerror strsignal \
   sysconf times sbrk gettimeofday ffs snprintf vsnprintf \
   pstat_getstatic pstat_getdynamic sysmp getsysinfo table sysctl \
-  realpath canonicalize_file_name)
+  realpath canonicalize_file_name __fsetlocking)
   AC_DEFINE(HAVE_SYS_ERRLIST, 1, [Define if you have the sys_errlist variable.])
   AC_DEFINE(HAVE_SYS_NERR,    1, [Define if you have the sys_nerr variable.])
   AC_DEFINE(HAVE_SYS_SIGLIST, 1, [Define if you have the sys_siglist variable.])
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/libiberty/fopen_unlocked.c	26 Apr 2005 00:17:20 -0000	1.2.2.2
@@ -0,0 +1,136 @@
+/* Implement fopen_unlocked and related functions.
+   Copyright (C) 2005 Free Software Foundation, Inc.
+   Written by Kaveh R. Ghazi <ghazi@caip.rutgers.edu>.
+
+This file is part of the libiberty library.
+Libiberty is free software; you can redistribute it and/or
+modify it under the terms of the GNU Library General Public
+License as published by the Free Software Foundation; either
+version 2 of the License, or (at your option) any later version.
+
+Libiberty is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+Library General Public License for more details.
+
+You should have received a copy of the GNU Library General Public
+License along with libiberty; see the file COPYING.LIB.  If
+not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/*
+
+@deftypefn Extension void unlock_stream (FILE * @var{stream})
+
+If the OS supports it, ensure that the supplied stream is setup to
+avoid any multi-threaded locking.  Otherwise leave the @code{FILE}
+pointer unchanged.  If the @var{stream} is @code{NULL} do nothing.
+
+@end deftypefn
+
+@deftypefn Extension void unlock_std_streams (void)
+
+If the OS supports it, ensure that the standard I/O streams,
+@code{stdin}, @code{stdout} and @code{stderr} are setup to avoid any
+multi-threaded locking.  Otherwise do nothing.
+
+@end deftypefn
+
+@deftypefn Extension FILE * fopen_unlocked (const char *@var{path}, const char * @var{mode})
+
+Opens and returns a @code{FILE} pointer via @code{fopen}.  If the
+operating system supports it, ensure that the stream is setup to avoid
+any multi-threaded locking.  Otherwise return the @code{FILE} pointer
+unchanged.
+
+@end deftypefn
+
+@deftypefn Extension FILE * fdopen_unlocked (int @var{fildes}, const char * @var{mode})
+
+Opens and returns a @code{FILE} pointer via @code{fdopen}.  If the
+operating system supports it, ensure that the stream is setup to avoid
+any multi-threaded locking.  Otherwise return the @code{FILE} pointer
+unchanged.
+
+@end deftypefn
+
+@deftypefn Extension FILE * freopen_unlocked (const char * @var{path}, const char * @var{mode}, FILE * @var{stream})
+
+Opens and returns a @code{FILE} pointer via @code{freopen}.  If the
+operating system supports it, ensure that the stream is setup to avoid
+any multi-threaded locking.  Otherwise return the @code{FILE} pointer
+unchanged.
+
+@end deftypefn
+
+*/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#include <stdio.h>
+#ifdef HAVE_STDIO_EXT_H
+#include <stdio_ext.h>
+#endif
+
+#include "libiberty.h"
+
+/* This is an inline helper function to consolidate attempts to unlock
+   a stream.  */
+
+static inline void unlock_1 PARAMS ((FILE *const fp ATTRIBUTE_UNUSED));
+static inline void
+unlock_1 (fp)
+     FILE *const fp ATTRIBUTE_UNUSED;
+{
+#if defined(HAVE___FSETLOCKING) && defined(FSETLOCKING_BYCALLER)
+  if (fp)
+    __fsetlocking (fp, FSETLOCKING_BYCALLER);
+#endif
+}
+
+void
+unlock_stream (fp)
+     FILE *fp;
+{
+  unlock_1 (fp);
+}
+
+void
+unlock_std_streams ()
+{
+  unlock_1 (stdin);
+  unlock_1 (stdout);
+  unlock_1 (stderr);
+}
+
+FILE *
+fopen_unlocked (path, mode)
+     const char *path;
+     const char *mode;
+{
+  FILE *const fp = fopen (path, mode);
+  unlock_1 (fp);
+  return fp;
+}
+
+FILE *
+fdopen_unlocked (fildes, mode)
+     int fildes;
+     const char *mode;
+{
+  FILE *const fp = fdopen (fildes, mode);
+  unlock_1 (fp);
+  return fp;
+}
+
+FILE *
+freopen_unlocked (path, mode, stream)
+     const char *path;
+     const char *mode;
+     FILE *stream;
+{
+  FILE *const fp = freopen (path, mode, stream);
+  unlock_1 (fp);
+  return fp;
+}
--- gcc-4.0.0.orig/libjava/ChangeLog	21 Apr 2005 05:20:10 -0000	1.3391.2.53
+++ gcc-4.0.0/libjava/ChangeLog	29 Apr 2005 18:39:53 -0000	1.3391.2.56
@@ -1,3 +1,28 @@
+2005-04-26  Luca Barbieri  <luca.barbieri@gmail.com>
+
+	PR libgcj/21136:
+	* gnu/java/nio/channels/FileChannelImpl.java (tryLock): Pass
+	'false' to native lock().
+	(lock): Pass 'true' to native lock().
+
+2005-04-27  Thomas Fitzsimmons  <fitzsim@redhat.com>
+
+	* Makefile.am (ordinary_java_source_files): Add
+	gnu/java/net/protocol/https/Handler.java.
+	* Makefile.in: Regenerate.
+	* java/net/URL.java: Remove org.metastatic.jessie from default
+	protocol search path.
+
+2005-04-27  Chris Burdess  <dog@gnu.org>
+
+	* gnu/java/net/protocol/https/Handler.java: New file.
+
+2005-04-26  Thomas Fitzsimmons  <fitzsim@redhat.com>
+
+	PR libgcj/21233:
+	* gij.cc (version): Properly quote java version.
+	(main): Fix typo in comment.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/libjava/Makefile.am	17 Apr 2005 06:51:06 -0000	1.455.2.12
+++ gcc-4.0.0/libjava/Makefile.am	28 Apr 2005 01:34:20 -0000	1.455.2.13
@@ -3231,6 +3231,7 @@
 gnu/java/net/protocol/http/event/ConnectionListener.java \
 gnu/java/net/protocol/http/event/RequestEvent.java \
 gnu/java/net/protocol/http/event/RequestListener.java \
+gnu/java/net/protocol/https/Handler.java \
 gnu/java/net/protocol/jar/Connection.java \
 gnu/java/net/protocol/jar/Handler.java \
 gnu/java/nio/ChannelInputStream.java \
--- gcc-4.0.0.orig/libjava/configure.ac	6 Apr 2005 21:38:26 -0000	1.19.2.4
+++ gcc-4.0.0/libjava/configure.ac	2 May 2005 04:38:05 -0000
@@ -627,6 +627,8 @@
 	;;
     esac
     ;;
+ rtems)
+    ;;
  win32)
     ;;
  decosf1 | irix | mach | os2 | solaris | dce | vxworks)
--- gcc-4.0.0.orig/libjava/gij.cc	2 Apr 2005 02:30:39 -0000	1.25.2.1
+++ gcc-4.0.0/libjava/gij.cc	26 Apr 2005 21:00:03 -0000	1.25.2.2
@@ -40,7 +40,7 @@
 static void
 version ()
 {
-  printf ("java version " JV_VERSION "\n");
+  printf ("java version \"" JV_VERSION "\"\n");
   printf ("gij (GNU libgcj) version %s\n\n", __VERSION__);
   printf ("Copyright (C) 2005 Free Software Foundation, Inc.\n");
   printf ("This is free software; see the source for copying conditions.  There is NO\n");
@@ -315,7 +315,7 @@
     }
 
   // -jar mode overrides all other modes of specifying class path:
-  // -CLASSPATH, -Djava.class.path, -classpath and -cp.
+  // CLASSPATH, -Djava.class.path, -classpath and -cp.
   if (jar_mode)
     {
       char* darg = (char*) JvMalloc (strlen (argv[i])
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/libjava/gnu/java/net/protocol/https/Handler.java	28 Apr 2005 01:34:47 -0000	1.1.2.1
@@ -0,0 +1,76 @@
+/* Handler.java --
+   Copyright (C) 2004, 2005  Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.net.protocol.https;
+
+import gnu.java.net.protocol.http.HTTPConnection;
+import gnu.java.net.protocol.http.HTTPURLConnection;
+
+import java.io.IOException;
+import java.net.URL;
+import java.net.URLConnection;
+import java.net.URLStreamHandler;
+
+/**
+ * An HTTPS URL stream handler.
+ *
+ * @author Chris Burdess (dog@gnu.org)
+ */
+public class Handler
+  extends URLStreamHandler
+{
+
+  /**
+   * Returns the default HTTPS port (443).
+   */
+  protected int getDefaultPort()
+  {
+    return HTTPConnection.HTTPS_PORT;
+  }
+
+  /**
+   * Returns an HTTPURLConnection for the given URL.
+   */
+  public URLConnection openConnection(URL url)
+    throws IOException
+  {
+    return new HTTPURLConnection(url);
+  }
+
+}
+
--- gcc-4.0.0.orig/libjava/gnu/java/nio/channels/FileChannelImpl.java	10 Mar 2005 16:09:35 -0000	1.7.4.1
+++ gcc-4.0.0/libjava/gnu/java/nio/channels/FileChannelImpl.java	29 Apr 2005 18:40:00 -0000	1.7.4.2
@@ -419,7 +419,7 @@
     try
       {
 	begin();
-        lock(position, size, shared, true);
+        lock(position, size, shared, false);
 	completed = true;
 	return new FileLockImpl(this, position, size, shared);
       }
@@ -451,7 +451,7 @@
 
     try
       {
-	boolean lockable = lock(position, size, shared, false);
+	boolean lockable = lock(position, size, shared, true);
 	completed = true;
 	return (lockable
 		? new FileLockImpl(this, position, size, shared)
--- gcc-4.0.0.orig/libjava/java/net/URL.java	4 Apr 2005 17:58:28 -0000	1.46.2.1
+++ gcc-4.0.0/libjava/java/net/URL.java	28 Apr 2005 01:34:48 -0000	1.46.2.2
@@ -125,7 +125,7 @@
 public final class URL implements Serializable
 {
   private static final String DEFAULT_SEARCH_PATH =
-    "org.metastatic.jessie|gnu.java.net.protocol|gnu.inet";
+    "gnu.java.net.protocol|gnu.inet";
 
   // Cached System ClassLoader
   private static ClassLoader systemClassLoader;
--- gcc-4.0.0.orig/libstdc++-v3/ChangeLog	21 Apr 2005 05:20:38 -0000	1.2917.2.26
+++ gcc-4.0.0/libstdc++-v3/ChangeLog	30 Apr 2005 22:55:29 -0000	1.2917.2.36
@@ -1,3 +1,111 @@
+2005-04-30  Paolo Carlini  <pcarlini@suse.de>
+	    Nathan Myers  <ncm@cantrip.org>
+
+	PR libstdc++/21286
+	* include/bits/fstream.tcc (basic_filebuf<>::xsgetn):
+	Loop on short reads; remove the work-around for
+	libstdc++/20806, not needed anymore.
+
+2005-04-29  Paolo Carlini  <pcarlini@suse.de>
+
+	* include/tr1/type_traits (is_convertible): Adjust according
+	to the resolution of TR1 issue 3.20.
+	* testsuite/tr1/4_metaprogramming/relationships_between_types/
+	is_convertible/is_convertible.cc: Add tests.
+
+2005-04-28  Paolo Carlini  <pcarlini@suse.de>
+	    Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	PR libstdc++/21244 (cont)
+	* include/bits/cpp_type_traits.h (struct __traitor): Convert
+	to bool the values.
+	* include/bits/stl_algo.h: Convert _S_threshold to int.
+	* include/bits/stl_bvector.h: Revert previous change, convert
+	_S_word_bit to int.
+	* include/debug/formatter.h: Convert __max_parameters to
+	size_t.
+	* include/ext/mt_allocator.h: Likewise for _S_chunk_size.
+	* include/ext/pool_allocator.h: Likewise for _S_max_bytes and
+	_S_align.
+	* include/ext/rope: Likewise for _S_alloc_granularity; convert
+	_S_max_rope_depth to int.
+	* include/ext/ropeimpl.h: Convert _S_path_cache_len to int;
+	_S_max_rope_depth to int; _S_copy_max to size_t.
+
+2005-04-27  Benjamin Kosnik  <bkoz@redhat.com>
+
+	* docs/doxygen/user.cfg.in: Update to doxygen-1.4.2.
+	* docs/doxygen/doxygroups.cc: Update namespace comments.
+
+2005-04-27  Dominik Strasser  <dominik.strasser@infineon.com>
+	    Paolo Carlini  <pcarlini@suse.de>
+
+	PR libstdc++/21244
+	* include/bits/stl_bvector.h: Change the anonymous enum
+	at namespace scope to _S_word_bit_enum.
+	* testsuite/23_containers/vector/bool/21244.cc: New.
+
+2005-04-27  Paolo Carlini  <pcarlini@suse.de>
+
+	* include/tr1/type_traits (has_trivial_copy, has_trivial_assign,
+	has_nothrow_copy, has_nothrow_assign): Adjust according to the
+	resolution of TR1 issue 3.21.
+	* testsuite/testsuite_tr1.h (test_copy_property,
+	test_assign_property): Remove.
+	* testsuite/tr1/4_metaprogramming/type_properties/
+	has_nothrow_assign/has_nothrow_assign.cc: Adjust.
+	* testsuite/tr1/4_metaprogramming/type_properties/
+	has_nothrow_copy/has_nothrow_copy.cc: Likewise.
+	* testsuite/tr1/4_metaprogramming/type_properties/
+	has_trivial_assign/has_trivial_assign.cc: Likewise.
+	* testsuite/tr1/4_metaprogramming/type_properties/
+	has_trivial_copy/has_trivial_copy.cc: Likewise.
+
+2005-04-26  Jones Desougi  <jones@ingate.com>
+
+	PR libstdc++/21131
+	* linkage.m4: Fix comments.
+
+2005-04-25  Paolo Carlini  <pcarlini@suse.de>
+
+	PR libstdc++/21035
+	* include/bits/basic_string.h (compare): Adjust the documentation
+	to match the implementation and the standard.
+
+2005-04-25  Paolo Carlini  <pcarlini@suse.de>
+
+	PR libstdc++/20914
+	* include/bits/locale_facets.tcc (__int_to_char(_CharT*, _ValueT,
+	const _CharT*, ios_base::fmtflags, bool)): Don't deal with numeric
+	base or sign here, instead...
+	(_M_insert_int(_OutIter, ios_base&, _CharT, _ValueT)): ... here,
+	after adding the grouping. This fixes the bug and also allows to
+	clean-up the code dealing with integer types.
+	(_M_group_int(const char*, size_t, _CharT, ios_base&, _CharT*,
+	_CharT*, int&)): Simplify, remove bits dealing with numeric base.
+	(__int_to_char(_CharT*, unsigned long, const _CharT*,
+	ios_base::fmtflags), __int_to_char(_CharT*, unsigned long long,
+	const _CharT*, ios_base::fmtflags)): Remove hackish fix for
+	libstdc++/15565.
+	(__int_to_char(_CharT*, long, const _CharT*, ios_base::fmtflags),
+	__int_to_char(_CharT*, long long, const _CharT*, ios_base::fmtflags)):
+	Simplify, don't pass the sign.
+	(_M_insert_float(_OutIter, ios_base&, _CharT, char, _ValueT)):
+	Deal with a sign at the beginning of __cs; robustify the grouping	
+	check.
+	* testsuite/22_locale/num_put/put/char/20914.cc: New.
+	* testsuite/22_locale/num_put/put/wchar_t/20914.cc: Likewise.
+
+2005-04-25  Earl Chew  <earl_chew@agilent.com>
+	    Christopher Jefferson  <chris@bubblescope.net>
+
+	* include/bits/stl_tree.h (_Rb_tree<>::_M_insert): Don't leak
+	memory if _M_key_compare throws.
+
+2005-04-24  Paolo Carlini  <pcarlini@suse.de>
+
+	* docs/html/ext/lwg-active.html, lwg-defects.html: Import Revision 35.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/libstdc++-v3/linkage.m4	25 Jun 2004 17:45:42 -0000	1.10
+++ gcc-4.0.0/libstdc++-v3/linkage.m4	26 Apr 2005 15:52:14 -0000	1.10.38.1
@@ -202,7 +202,7 @@
 dnl
 dnl argument 1 is name of function to check
 dnl
-dnl ASSUMES argument is a math function with TWO parameters
+dnl ASSUMES argument is a stdlib function with TWO parameters
 dnl
 dnl GLIBCXX_CHECK_STDLIB_DECL_AND_LINKAGE_2
 AC_DEFUN([GLIBCXX_CHECK_STDLIB_DECL_AND_LINKAGE_2], [
@@ -231,7 +231,7 @@
 dnl
 dnl argument 1 is name of function to check
 dnl
-dnl ASSUMES argument is a function with THREE parameters
+dnl ASSUMES argument is a stdlib function with THREE parameters
 dnl
 dnl GLIBCXX_CHECK_STDLIB_DECL_AND_LINKAGE_3
 AC_DEFUN([GLIBCXX_CHECK_STDLIB_DECL_AND_LINKAGE_3], [
--- gcc-4.0.0.orig/libstdc++-v3/docs/doxygen/doxygroups.cc	24 Nov 2004 04:11:08 -0000	1.12
+++ gcc-4.0.0/libstdc++-v3/docs/doxygen/doxygroups.cc	27 Apr 2005 23:41:11 -0000	1.12.12.1
@@ -1,5 +1,5 @@
 /*
-   Copyright (C) 2001, 2002 Free Software Foundation, Inc.
+   Copyright (C) 2001, 2002, 2005 Free Software Foundation, Inc.
    See license.html for license.
 
    This just provides documentation for stuff that doesn't need to be in the
@@ -23,19 +23,17 @@
  *  @brief Everything defined by the TR1 is within namespace std::tr1.
 */
 /** @namespace __gnu_cxx
- *  @brief This namespace serves two purposes.
- *
- *  This namespace is used for two things:
- *  -  sequestering internal (implementation-only) names away from the
- *     global namespace; these are details of the implementation and should
- *     not be touched by users
- *  -  GNU extensions for public use
- *
- *  This is still fluid and changing rapidly.  Currently the rule is:  if an
- *  entitity is found in the user-level documentation, it falls into the
- *  second category.
+ *  @brief GNU extensions for public use.
+*/
+/** @namespace __gnu_cxx::balloc
+ *  @brief Related to __gnu_cxx::bitmap_allocator.
+*/
+/** @namespace __gnu_internal
+ *  @brief GNU implemenation details, not for public use.
+*/
+/** @namespace __gnu_debug
+ *  @brief GNU debug mode implemenation details.
 */
-
 // // // // // // // // // // // // // // // // // // // // // // // //
 /** @addtogroup SGIextensions STL extensions from SGI
 Because libstdc++-v3 based its implementation of the STL subsections of
@@ -131,10 +129,11 @@
  *  platform.  It is summarized at http://www.codesourcery.com/cxx-abi/
  *  along with the current specification.
  *
- *  For users of GCC 3.x, entry points are available in <cxxabi.h>, which notes,
- *  <em>"It is not normally necessary for user programs to include this header,
- *  or use the entry points directly.  However, this header is available
- *  should that be needed."</em>
+ *  For users of GCC greater than or equal to 3.x, entry points are
+ *  available in <cxxabi.h>, which notes, <em>"It is not normally
+ *  necessary for user programs to include this header, or use the
+ *  entry points directly.  However, this header is available should
+ *  that be needed."</em>
 */
 
 namespace abi {
